<template>
  <div class="filter" v-click-outside="close">
    <input v-model="isChecked" type="checkbox" id="checkbox_toggle" />
    <label class="flex filter-label" for="checkbox_toggle"
      ><p>Filter <span class="d-block-ls">by status</span></p>
      <img src="@/assets/icon-arrow-down.svg" />
    </label>
    <div class="filter--options">
      <label class="flex filter--option">
        <input type="checkbox" id="paid" @change="setFilter" />
        <span class="filter--check">
          <img src="@/assets/icon-check.svg" />
        </span>
        <span>Paid</span>
      </label>
      <label class="flex filter--option">
        <input type="checkbox" id="pending" @change="setFilter" />
        <span class="filter--check">
          <img src="@/assets/icon-check.svg" />
        </span>
        <span>Pending</span>
      </label>
      <label class="flex filter--option">
        <input type="checkbox" id="draft" @change="setFilter" />
        <span class="filter--check">
          <img src="@/assets/icon-check.svg" />
        </span>
        <span>Draft</span>
      </label>
    </div>
  </div>
</template>

<script>
export default {
  emits: ["change-filter"],
  data() {
    return {
      isChecked: false,
      filters: {
        paid: false,
        pending: false,
        draft: false,
      },
    };
  },
  methods: {
    setFilter(event) {
      const inputId = event.target.id;
      const isActive = event.target.checked;
      const updatedFilters = {
        ...this.filters,
        [inputId]: isActive,
      };
      this.filters = updatedFilters;
      this.$emit("change-filter", updatedFilters);
    },

    close() {
      this.isChecked = false;
    },
  },
};
</script>

<style scoped>
input[type="checkbox"] {
  display: none;
}
.filter {
  --gap: 1rem;
  position: relative;
  z-index: 9;
}
.filter-label {
  gap: 0.5rem;
  cursor: pointer;
  font-weight: var(--fw-700);
}

.filter--options {
  display: none;
  position: absolute;
  top: 3rem;
  flex-direction: column;
  gap: 0.5rem;
  width: 10rem;
  border-radius: 0.5rem;
  padding: 1.5rem;
  background: hsl(var(--clr-dropdown-bg));
  box-shadow: var(--clr-dropdown-shadow) 0px 10px 20px;
}
.filter--option {
  cursor: pointer;
}
.filter--check {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 1rem;
  height: 1rem;
  border-radius: 2px;
  background: hsl(var(--clr-checkbox-bg));
}
.filter--check > img {
  opacity: 0;
}

input[type="checkbox"]:checked ~ label > img {
  transform: rotate(-180deg);
}

input[type="checkbox"]:checked ~ .filter--options {
  display: flex;
}
input:checked + span > img {
  opacity: 1;
}
input:checked + span {
  background: hsl(var(--clr-primary-100));
}
input:hover + span {
  border: 1px solid hsl(var(--clr-primary-100));
}
</style>
